<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml" >
<xsl:output omit-xml-declaration="yes" version="1.0" indent="no" method="text" encoding="UTF-8" media-type="text/plain"/>
<xsl:strip-space elements="*"/>

<xsl:template match="doxygen">
<xsl:copy>
<xsl:apply-templates select="compounddef"/>
//Maciej Kucia 2014//
</xsl:copy>
</xsl:template>

<xsl:template match="compounddef">====== <xsl:value-of select="./compoundname"/> ======
<xsl:apply-templates select="inheritancegraph"/>
>> <xsl:value-of select="./briefdescription/para"/>
> <xsl:value-of select="./detaileddescription/para"/>

<xsl:apply-templates select="sectiondef"/>
<xsl:apply-templates select="listofallmembers"/>

Location: [[\\<xsl:value-of select="./location/@file"/>]]
----
</xsl:template>

<xsl:template match="sectiondef[@kind  = 'public-func']">

===== Functions =====
<xsl:apply-templates select="memberdef"/>
</xsl:template>

<xsl:template match="sectiondef[@kind  = 'private-attrib']">

===== Private Attributes =====
<xsl:apply-templates select="memberdef"/>
</xsl:template>

<xsl:template match="sectiondef[@kind  = 'property']">

===== Properties =====
<xsl:apply-templates select="memberdef"/>
</xsl:template>

<xsl:template match="sectiondef[@kind  = 'private-static-func']">

===== Private Static Functions =====
<xsl:apply-templates select="memberdef"/>
</xsl:template>

<xsl:template match="listofallmembers">
===== All Members =====
<xsl:apply-templates select="member"/>
</xsl:template>

<xsl:template match="inheritancegraph">

|<xsl:for-each select="./node">[[#<xsl:value-of select="./label"/>]]  <xsl:choose>
<xsl:when test="position() != last()"> -> </xsl:when>
</xsl:choose></xsl:for-each>|

</xsl:template>
  
<xsl:template match="memberdef[@kind = 'function']">
^ <xsl:value-of select="./@prot"/>  ^  <xsl:value-of select="./type"/> ^**[[#<xsl:value-of select="./name"/>]]** <xsl:value-of select="./argsstring"/> ^
| //<xsl:value-of select="./briefdescription/para"/>// |||</xsl:template>

<xsl:template match="memberdef[(@kind = 'variable') or (@kind = 'property')]">
^<xsl:value-of select="./type"/>^**[[#<xsl:value-of select="./name"/>]]**^
|//<xsl:value-of select="./briefdescription"/>// ||</xsl:template>

<xsl:template match="member">
<xsl:call-template name="detaileddescription">
<xsl:with-param name="nodes" select="../../sectiondef/memberdef[@id=current()/@refid]"/>
</xsl:call-template>
</xsl:template>

<xsl:template name="detaileddescription">
<xsl:param name="nodes"/>
<xsl:for-each select="$nodes">
==== <xsl:value-of select="./name"/> ==== 
^ <xsl:value-of select="./definition"/>  ^ <xsl:value-of select="./argsstring"/>  ^
| //<xsl:value-of select="./briefdescription"/>// ||
<xsl:apply-templates select="./detaileddescription"/>
</xsl:for-each>
</xsl:template>


<xsl:template match="detaileddescription">
<xsl:if test="./para/parameterlist/parameteritem"><xsl:for-each select="./para/parameterlist/parameteritem">| <xsl:value-of select="./parameternamelist/parametername"/> | <xsl:value-of select="./parameterdescription/para"/> |
</xsl:for-each></xsl:if><xsl:if test="./para/simplesect"><xsl:for-each select="./para/simplesect">| **<xsl:value-of select="./@kind"/>** | <xsl:value-of select="./para"/>|
</xsl:for-each></xsl:if><xsl:if test="./para/text()">| //<xsl:value-of select="./para/text()" />// ||</xsl:if>
</xsl:template>


<xsl:template match="collaborationgraph"></xsl:template>

</xsl:stylesheet>